app.directive 'accOverviewZhengquan', ->
  restrict: 'E'
  replace: true
  templateUrl: './app/account/directives/overview-panels/acc-overview-zhengquan.html'
  controller: [
    '$scope'
    '$element'
    'tql'
    ($scope, $element, tql) ->
      $scope.data =
        range: 7
        busiAcc: ''

      $scope.error =
        right: false
        rightInfo: ''

      $scope.loadData = (period = 1) ->
        periods = ([7, 30, 3 * 30]).map((e) -> e * 24 * 3600 * 1000)
        getDateString = (tick) ->
          date = new Date tick
          year = date.getFullYear()
          month = date.getMonth() + 1
          day = date.getDate()

          month = '0' + month if month < 10
          day = '0' + day if day < 10

          year + month + day

        period = 0 if period < 0 || period >= periods.length
        now = Date.now()

        beginDay = getDateString now - periods[period]
        endDay = getDateString now

        tql.account['客户累计收益查询']
          CIF_ACCOUNT: '#{{USER_CIFACCOUNT}}'
          BEGIN_DATE: beginDay
          END_DATE: endDay
          STAT_PERIOD: '0'
        ,
          'JSONIX'
        ,
          true
        .then (res) ->
          if res.list.length <= 0
            # $scope.error.right = true
            # $scope.error.rightInfo = '暂无累计收益数据'
            dayList = [10..0]
            value1 = ((-> 0) data for data in [0..10])
            value2 = ((-> 0) data for data in [0..10])
          else
            parseDate = (str) ->
              str.substr(4, 2) + '-' + str.substr(6, 2)

            dayList = []
            value1 = []
            value2 = []
            res.list.forEach (elem) ->
              dayList.push parseDate(elem.PROFIT_DATE || elem.TRADE_DATE)
              value1.push +elem.DAY_PROFIT_COMM
              value2.push +elem.DAY_PROFIT_CREDIT

            return {
              dayList: dayList
              value1: value1
              value2: value2
            }
        , (reason) ->
          return {
            dayList: [10..0]
            value1: ((-> 0) data for data in [0..10])
            value2: ((-> 0) data for data in [0..10])
          }
        .then (datas) ->
          $scope.data.xDays = datas.dayList
          $scope.data.series = [
            name: '信用收益'
            type: 'line'
            stack: '信用'
            data: datas.value2
            itemStyle:
              normal:
                color: '#6ab4e1'
          ,
            name: '普通收益'
            type: 'line'
            stack: '信用'
            data: datas.value1
            itemStyle:
              normal:
                color: '#e6626c'
          ]
          $scope.refreshChart()

      # 资金账号的详细信息
      $scope.accDetails = []
      $scope.accDetailActived = null
      $scope.loadAccDetail = ->
        console.log 'load acc details'
        tql.account['客户资金精确快速查询']
          busin_account: '#{{USER_BUSI_ACC}}'
          client_id: ''
          money_type: ' '
        ,
          'JSONIX'
        .then (res) ->
          $scope.accDetails = res.list
          $scope.accDetailActived = res.list[0]

      # echarts相关操作
      accEcharts =
        handle: null
        init: ->
          elem = $element.find 'div.acc-overview-echarts-container-2'
          dom = elem[0]
          this.handle = echarts.init dom
        show: ->
          this.handle.setOption
            tooltip:
              trigger: 'axis'
              formatter: (objs) ->
                info = (((e) -> e.seriesName + ': ' + e.data + '元') elem for elem in objs)
                info.join '<br/>'
            grid:
              x: 80, x2: 40, y: 10, y2: 30
            xAxis: [
              type: 'category'
              boundaryGap: false
              data: $scope.data.xDays
            ]
            yAxis: [
              type: 'value'
            ]
            series: $scope.data.series

      $scope.refreshChart = ->
        accEcharts.init()
        accEcharts.show()


      # init
      $scope.init = ->
        # 加载资金账号信息
        tql.getUserInfo().then (info) ->
          $scope.data.busiAcc = info.USER_BUSI_ACC

        # 加载图表数据
        $scope.loadData()

        # 加载资金账号详细信息
        $scope.loadAccDetail()
  ]