
app.factory 'accQbDate', ->
  toStr: (date) ->
    date = new Date date if typeof date is 'number'
    year = date.getFullYear()
    month = date.getMonth() + 1
    day = date.getDate()
    month = '0' + month if month < 10
    day = '0' + day if day < 10
    return "#{year}#{month}#{day}"
  convert: (date, type) ->
    date = date.getTime() if date instanceof Date
    day = 24 * 3600 * 1000
    switch type
      when '今天'
        return new Date date
      when '最近一周'
        return new Date date - day * 7
      when '最近一个月'
        return new Date date - day * 30
      when '最近三个月'
        return new Date date - day * 30 * 3

    return new Date date - day

app.factory 'accQbFilter', [
  '$timeout'
  ($timeout) ->
    (cols, list) ->
      filters = {}
      cols.forEach (col) ->
        key = col[1]
        filter = col[2]
        show = col[3]
        return null if !filter || !show
        filters[key] = filter

      list.forEach (record, index) ->
        record.isNew = true
        $timeout ->
          record.isNew = false
        , 1200 + index * 30
        Object.keys(record).forEach (key) ->
          return null if !filters.hasOwnProperty key
          filter = filters[key]
          rawVal = record[key]

          if angular.isFunction filter
            ret = filter(rawVal) || rawVal
            if typeof ret.then is 'function'
              # 异步的promise函数
              ret.then (res) -> record[key] = res || rawVal
            else
              record[key] = ret || rawVal
          else if angular.isObject(filter) || angular.isArray(filter)
            record[key] = filter[rawVal] || rawVal
]


