# 本页面集合了对账单下面的所有控制器：
#   对账单/证券交易
#   对账单/融资融券
#   对账单/期货交易


app.directive 'accQbDzdZhengquanjiaoyi', ->
  restrict: 'E'
  replace: true
  scope: {}
  templateUrl: './app/account/directives/query-bills/acc-qb-dzd-zhengquanjiaoyi.html'
  controller: [
    '$scope'
    'tql'
    ($scope, tql) ->
      $scope.filters =
        dateType: [
          '今天'
          '最近一周'
          '最近三个月'
          '自定义'
        ]
        tradeType: [
          '全部'
          '证券交易'
          '银行交易'
          '证券转银行'
          '银行转证券'
        ]
        quickType: [
          '所有交易'
          '证券买入'
          '证券卖出'
        ]
        fundAcc: [
          '03888800008888'
        ]

      $scope.data =
        dateType: $scope.filters.dateType[0]
        tradeType: $scope.filters.tradeType[0]
        quickType: $scope.filters.quickType[0]
        fundAcc: $scope.filters.fundAcc[0]

      ((key) ->
        trueKey = 'filters.' + key
        $scope.$watch trueKey, (newVal) ->
          $scope.data[key] = newVal[0]

      ) key for own key of $scope.filters

      $scope.$watch 'data.dateType', (newVal) ->
        now = Date.now()
        aDay = 24 * 3600 * 1000

        switch $scope.data.dateType
          when $scope.filters.dateType[0]
            beginDate = new Date now
          when $scope.filters.dateType[1]
            beginDate = new Date now - 7 * aDay
          when $scope.filters.dateType[2]
            beginDate = new Date now - 30 * aDay
          when $scope.filters.dateType[3]
            beginDate = new Date now - 3 * 30 * aDay
          when $scope.filters.dateType[4]
            break
          else
            beginDate = new Date now

        $scope.input.beginDate = beginDate
        $scope.input.endDate = new Date now



      $scope.spec =
        today:
          interface: tql.account['对账单查询-历史证券合并']
          cols: [
            ['清算日期', 'clear_date', null, true]
            ['交收日期', 'init_date', null, true]
            ['发生日期', 'entrust_date', null, true]
            ['发生时间', 'entrust_time', null, true]
            ['业务标志', 'business_flag', null, true]
            ['业务说明', 'business_name', null, true]
            ['客户姓名', 'client_name', null, true]
            ['资金账户', 'busin_account', null, true]
            ['币种类别', 'money_type', null, true]
            ['交易类别', 'exchange_type', null, true]
            ['证券账号', 'stock_account', null, true]
            ['清算金额', 'clear_balance', null, true]
            ['当前余额', 'post_balance', null, true]
            ['当前数量', 'post_amount', null, true]
            ['申请编号', 'report_no', null, true]
            ['证券代码', 'stock_code', null, true]
            ['证券名称', 'stock_name', null, true]
            ['买卖方向', 'entrust_bs', null, true]
            ['成交数量', 'business_amount', null, true]
            ['成交价格', 'business_price', null, true]
            ['成交金额', 'business_balance', null, true]
          ]

      $scope.activeSpec = $scope.spec.today

      # 输入的数据
      $scope.input =
        beginDate: ''
        endDate: ''
        posStr: ''
      $scope.output =
        totalVal: 0

      # 标识集
      $scope.flags =
        noMore: false

      $scope.tableList = []

      $scope.query = ->
        return null if $scope.flags.noMore

        formatDate = (tick) ->
          year = tick.getFullYear()
          month = tick.getMonth() + 1
          day = tick.getDate()
          month = '0' + month if month < 10
          day = '0' + day if day < 10
          year + month + day

        $scope.activeSpec.interface
          client_id: ''
          busin_account: '#{{USER_BUSI_ACC}}'
          begin_date: formatDate $scope.input.beginDate
          end_date: formatDate $scope.input.endDate
          position_str: $scope.input.posStr
          print_flag: '0'
          request_num: '20'
        ,
          'JSONIX'
        .then((res) ->
          noMore = res.list.length <= 0
          $scope.flags.noMore = noMore
          if !noMore
            $scope.input.posStr = res.list[res.list.length - 1].position_str
            Array.prototype.push.apply $scope.tableList, res.list
          else
            $scope.$broadcast 'noMoreRecord'
          # 重新计算当前总值（字段因接口而异）
          sum = 0
          $scope.tableList.forEach (row) ->
            sum += (+row.business_balance)
          $scope.output.totalVal = sum
        )

      $scope.reload = ->
        $scope.input.posStr = ''
        $scope.tableList = []
        $scope.flags.noMore = false
        $scope.query()

      $scope.$on 'loadMoreRecord', $scope.query.bind $scope

      ((key) ->
        return null if key is 'dateType'
        trueKey = 'data.' + key
        $scope.$watch trueKey, $scope.reload.bind $scope
      ) key for own key of $scope.data

      $scope.init = ->
        tql.getUserInfo()
        .then (info) ->
          $scope.filters.fundAcc = [info.USER_BUSI_ACC]

      $scope.exportFile = ->
        $scope.$broadcast 'exportTable'

      $scope.printFile = ->
        window.print()
  ]


app.directive 'accQbDzdRongzirongquan', ->
  restrict: 'E'
  replace: true
  scope: {}
  templateUrl: './app/account/directives/query-bills/acc-qb-dzd-rongzirongquan.html'
  controller: [
    '$scope'
    'tql'
    ($scope, tql) ->
      $scope.filters =
        dateType: [
          '今天'
          '最近一周'
          '最近三个月'
          '自定义'
        ]
        tradeType: [
          '全部'
          '证券交易'
          '银行交易'
          '证券转银行'
          '银行转证券'
        ]
        quickType: [
          '所有交易'
          '融资买入'
          '融券卖出'
          '买券还券'
        ]
        fundAcc: [
          '03888800008888'
        ]

      $scope.data =
        dateType: $scope.filters.dateType[0]
        tradeType: $scope.filters.tradeType[0]
        quickType: $scope.filters.quickType[0]
        fundAcc: $scope.filters.fundAcc[0]

      $scope.spec =
        today:
          interface: tql.account['对账单查询-历史证券合并']
          cols: [
            ['清算日期', 'clear_date', null, true]
            ['交收日期', 'init_date', null, true]
            ['发生日期', 'entrust_date', null, true]
            ['发生时间', 'entrust_time', null, true]
            ['业务标志', 'business_flag', null, true]
            ['业务说明', 'business_name', null, true]
            ['客户姓名', 'client_name', null, true]
            ['资金账户', 'busin_account', null, true]
            ['币种类别', 'money_type', null, true]
            ['交易类别', 'exchange_type', null, true]
            ['证券账号', 'stock_account', null, true]
            ['清算金额', 'clear_balance', null, true]
            ['当前余额', 'post_balance', null, true]
            ['当前数量', 'post_amount', null, true]
            ['申请编号', 'report_no', null, true]
            ['证券代码', 'stock_code', null, true]
            ['证券名称', 'stock_name', null, true]
            ['买卖方向', 'entrust_bs', null, true]
            ['成交数量', 'business_amount', null, true]
            ['成交价格', 'business_price', null, true]
            ['成交金额', 'business_balance', null, true]
          ]

      $scope.activeSpec = $scope.spec.today

      ((key) ->
        trueKey = 'filters.' + key
        $scope.$watch trueKey, (newVal) ->
          $scope.data[key] = newVal[0]

      ) key for own key of $scope.filters

      # 输入的数据
      $scope.input =
        beginDate: ''
        endDate: ''
        posStr: ''
      $scope.output =
        totalVal: 0

      # 标识集
      $scope.flags =
        noMore: false

      $scope.tableList = []

      $scope.$watch 'data.dateType', (newVal) ->
        now = Date.now()
        aDay = 24 * 3600 * 1000

        switch $scope.data.dateType
          when $scope.filters.dateType[0]
            beginDate = new Date now
          when $scope.filters.dateType[1]
            beginDate = new Date now - 7 * aDay
          when $scope.filters.dateType[2]
            beginDate = new Date now - 30 * aDay
          when $scope.filters.dateType[3]
            beginDate = new Date now - 3 * 30 * aDay
          when $scope.filters.dateType[4]
            break
          else
            beginDate = new Date now

        $scope.input.beginDate = beginDate
        $scope.input.endDate = new Date now

      $scope.query = ->
        return null if $scope.flags.noMore

        formatDate = (tick) ->
          year = tick.getFullYear()
          month = tick.getMonth() + 1
          day = tick.getDate()
          month = '0' + month if month < 10
          day = '0' + day if day < 10
          year + month + day

        $scope.activeSpec.interface
          client_id: ''
          busin_account: '#{{USER_BUSI_ACC}}'
          begin_date: formatDate $scope.input.beginDate
          end_date: formatDate $scope.input.endDate
          position_str: $scope.input.posStr
          print_flag: '0'
          request_num: '20'
        ,
          'JSONIX'
        .then((res) ->
          noMore = res.list.length <= 0
          $scope.flags.noMore = noMore
          if !noMore
            $scope.input.posStr = res.list[res.list.length - 1].position_str
            Array.prototype.push.apply $scope.tableList, res.list
          else
            $scope.$broadcast 'noMoreRecord'
          # 重新计算当前总值（字段因接口而异）
          sum = 0
          $scope.tableList.forEach (row) ->
            sum += (+row.business_balance)
          $scope.output.totalVal = sum
        )

      $scope.reload = ->
        $scope.input.posStr = ''
        $scope.tableList = []
        $scope.flags.noMore = false
        $scope.query()

      $scope.$on 'loadMoreRecord', $scope.query.bind $scope

      ((key) ->
        return null if key is 'dateType'
        trueKey = 'data.' + key
        $scope.$watch trueKey, $scope.reload.bind $scope
      ) key for own key of $scope.data

      $scope.init = ->
        tql.getUserInfo()
        .then (info) ->
          $scope.filters.fundAcc = [info.USER_BUSI_ACC]

  ]