# 定义共同的分页结构

app.directive 'accQbTable', ->
  restrict: 'E'
  replace: true
  scope:
    tableCols: '='
    tableList: '='
    noMoreRecord: '='
  templateUrl: './app/account/directives/query-bills/acc-qb-table.html'
  controller: [
    '$scope'
    'tql'
    '$element'
    ($scope, tql, $element) ->
      $scope.data =
        currentPage: 0
        tqlInterface: null
        inParam: {}
    
      $scope.action =
        load: (n) ->
          console.log "load #{n} page"
        refresh: ->
          console.log "reload current page"
        loadMore: ->
          console.log "load more data"

      $scope.$on 'loading', ->
        $scope.status = 'loading'
      $scope.$on 'loadingFinished', ->
        $scope.status = 'loadingFinished'
        setTimeout ->
          $element.find('.acc-table-container').animate {
            scrollTop: 10000
          }, 'slow'
      $scope.$on 'exportTable', ->
        slice = Array.prototype.slice
        rows = $element.find 'table tr'
        rows = slice.call rows
        rows = rows.map (row, index) ->
          row = $ row
          cells = if index is 0 then row.find 'th' else row.find 'td'
          cells = (slice.call cells).map (cell) ->
            cell.innerText
          cells.join '\t'

        content = rows.join '\r\n'
        
        tag = document.createElement 'a'
        blob = new Blob [content], type: 'text/plain'
        evt = document.createEvent 'HTMLEvents'
        evt.initEvent 'click', false, false
        tag.download = '*.csv'
        tag.href = URL.createObjectURL blob
        tag.dispatchEvent evt
  ]