app.directive 'accQbWtcxZhengquanjiaoyi', ->
  restrict: 'E'
  replace: true
  scope: {}
  templateUrl: './app/account/directives/query-bills/acc-qb-template.html'
  controller: [
    '$scope'
    'tql'
    'accQbDate'
    'accQbFilter'
    ($scope, tql, accQbDate, accQbFilter) ->
      pageSize = 10
      $scope.filters =
        dateType: ['今天', '最近一周', '最近一个月', '最近三个月', '自定义']
        tradeType: ['全部', '上海', '深圳', '特转A', '特转B', '上海B', '深圳B', '其它']
        quickType: ['全部', '证券买入', '证券卖出'].map (name, index) ->
          name: name,
          selected: index is 0
        fundAcc: ['-']
        entrustStatus: ['全部', '未报', '待报', '已报', '已报待撤', '部成待撤', '部撤', '已撤', '部成', '已成', '废单']
      $scope.data =
        dateType: $scope.filters.dateType[0]
        tradeType: $scope.filters.tradeType[0]
        quickType: $scope.filters.quickType[0]
        fundAcc: $scope.filters.fundAcc[0]
        entrustStatus: $scope.filters.entrustStatus[0]
      $scope.flags =
        noMore: false
        show:
          toolsBar: false
          dateType: true
          tradeType: true
          quickType: true
          fundAcc: true
          moneyRange: false
          entrustStatus: true
      $scope.input =
        beginDate: ''
        endDate: ''
        posStr: ''
      $scope.output =
        tableList: []
        totalVal: 0
      $scope.spec =
        today:
          interface: tql.account['委托查询-证券交易当日委托']
          onRequest: (scope) ->
            exchange_type: ((name) ->
              ({
                '全部': ''
                '上海': '1'
                '深圳': '2'
                '特转A': '9'
                '特转B': 'A'
                '上海B': 'D'
                '深圳B': 'H'
                '其它': '0'
              })[name]
            )($scope.data.tradeType) # 交易类型
            busin_account: $scope.data.fundAcc # 资金账号
            client_id: '' # 应用系统编号
            stock_account: '' # 证券账号
            stock_code: '' # 证券代码
            entrust_no: '' # 委托编号
            bank_no: '' # 银行代码
            '@COUNT': String(pageSize) # 请求行数
            '@POS': $scope.input.posStr  #定位串
          cols: [
            ['委托编号', 'entrust_no', null, true]
            ['应用系统客户编号', 'client_id', null, false]
            ['客户姓名', 'client_name', null, false]
            ['资金账户', 'busin_account', null, false]
            ['币种类别', 'money_type', ['人民币'], true]
            ['分支机构', 'branch_no', null, false]
            ['证券账号', 'stock_account', null, true]
            ['买卖方向', 'entrust_bs', ['', '买入', '卖出'], true]
            ['申请编号', 'report_no', null, false]
            ['申报时间', 'report_time', null, false]
            ['委托日期', 'entrust_date', null, true]
            ['委接时间', 'entrust_time', ((v) -> ('000' + v).substr -8), true]
            ['交易类别', 'exchange_type', {
              '0': '未知'
              '1': '上海'
              '2': '深圳'
              '9': '特转A'
              'A': '特转B'
              'D': '上海B'
              'H': '深圳B'
            }, true]
            ['证券代码', 'stock_code', null, true]
            ['证券名称', 'stock_name', null, true]
            ['委托价格', 'entrust_price', null, true]
            ['委托数量', 'entrust_amount', null, true]
            ['委托买入冻结金额', 'entrust_buy_balance', null, false]
            ['成交数量', 'business_amount', null, true]
            ['成交金额', 'business_balance', null, true]
            ['撤单数量', 'withdraw_amount', null, true]
            ['委托状态', 'entrust_status', ['未报', '待报', '已报', '已报待撤', '部成待撤', '部撤', '已撤', '部成', '已成', '废单'], true]
            ['席位编号', 'seat_no', null, false]
            ['撤单标志', 'withdraw_flag', {'0': '-', '1': '撤单'}, false]
            ['委托属性', 'entrust_prop', null, false]
            ['信用交易摘要', 'busin_code', null, false]
          ]
        history:
          interface: tql.account['委托查询-证券交易历史委托']
          onRequest: () ->
            begin_date: accQbDate.toStr($scope.input.beginDate) # 起始时间
            end_date: accQbDate.toStr($scope.input.endDate) # 结束时间
            busin_account: $scope.data.fundAcc # 资金账号
            client_id: '' # 应用系统编号
            exchange_type: ((name) ->
              ({
                '全部': ''
                '上海': '1'
                '深圳': '2'
                '特转A': '9'
                '特转B': 'A'
                '上海B': 'D'
                '深圳B': 'H'
                '其它': '0'
              })[name]
            )($scope.data.tradeType) # 交易类型
            stock_account: '' # 证券账号
            stock_code: '' # 证券代码
            entrust_no: '' # 委托编号
            '@COUNT': String(pageSize) # 请求数量
            '@POS': $scope.input.posStr # 定位串
          cols: [
            ['交易日期', 'init_date', null, true],
            ['客户编号', 'client_id', null, true],
            ['客户姓名', 'client_name', null, true],
            ['资金账户', 'busin_account', null, true],
            ['币种类别', 'money_type', null, true],
            ['分支机构', 'branch_no', null, true],
            ['证券账号', 'stock_account', null, true],
            ['买卖方向', 'entrust_bs', null, true],
            ['申请编号', 'report_no', null, true],
            ['申报时间', 'report_time', null, true],
            ['委接时间', 'entrust_time', null, true],
            ['交易类别', 'exchange_type', null, true],
            ['证券代码', 'stock_code', null, true],
            ['证券名称', 'stock_name', null, true],
            ['委托价格', 'entrust_price', null, true],
            ['委托数量', 'entrust_amount', null, true],
            ['委托买入冻结金额', 'entrust_buy_balance', null, true],
            ['成交数量', 'business_amount', null, true],
            ['成交金额', 'business_balance', null, true],
            ['撤单数量', 'withdraw_amount', null, true],
            ['委托状态', 'entrust_status', {'2': '已报', '8': '已成', '9': '废单'}, true],
            ['席位编号', 'seat_no', null, true],
            ['委托属性', 'entrust_prop', null, true],
            ['信用交易摘要', 'busin_code', null, true]
          ]
      $scope.activeSpec = $scope.spec.today

      $scope.selectQuickType = ($index) ->
        $scope.quickType.forEach (type, index) ->
          type.selected = $index is index

      $scope.query = ->
        return null if $scope.flags.noMore
        $scope.$broadcast 'loading'
        console.info 'call $scope.query'
        spec = $scope.activeSpec
        spec.interface (spec.onRequest $scope), 'JSONIX', true
        .then (res) ->
          noMore = res.list.length <= pageSize  # 请求的数目是pageSize+1，如果应答的数目不足pageSize+1，则表示没有更多记录了
          $scope.flags.noMore = noMore
          if noMore
            $scope.$broadcast 'noMoreRecord'
          else
            res.list.pop()
            $scope.input.posStr = res.pos

          accQbFilter spec.cols, res.list # 处理应答字段
          Array.prototype.push.apply $scope.tableList, res.list   # 附加到列表后面，增量
          # 重新计算当前总值（字段因接口而异）
          sum = 0
          $scope.tableList.forEach (row) ->
            sum += (+row.business_balance)
          $scope.output.totalVal = sum
        , (reason) ->
          console.warn "加载时发生错误：#{reason}"
        .then ->
          $scope.$broadcast 'loadingFinished'

      $scope.reload = ->
        $scope.input.posStr = ''
        $scope.tableList = []
        $scope.flags.noMore = false
        $scope.query()

      $scope.init = ->
        tql.getUserInfo().then (info) ->
          $scope.filters.fundAcc = [info.USER_BUSI_ACC]

        # 收到table的加载更多消息后，增量查询
        $scope.$on 'loadMoreRecord', $scope.query.bind $scope
        # 筛选条件变化后，自动重新刷新
        ['tradeType', 'quickType', 'fundAcc'].forEach (key) ->
          filterKey = 'filters.' + key
          dataKey = 'data.' + key
          $scope.$watch filterKey, (newVal, oldVal) ->
            return null if newVal is oldVal
            $scope.data[key] = newVal[0]
          $scope.$watch dataKey, (newVal, oldVal) ->
            return null if newVal is oldVal
            console.warn "call reload by #{dataKey}=#{newVal}(#{oldVal})"
            $scope.reload()
        # 监听时间变化
        $scope.$watch 'data.dateType', (newVal) ->
          now = new Date
          $scope.input.endDate = now
          $scope.input.beginDate = accQbDate.convert now, newVal

          oldSpec = $scope.activeSpec
          $scope.activeSpec = if newVal is '今天' then $scope.spec.today else $scope.spec.history
          $scope.reload() if oldSpec isnt $scope.activeSpec
  ]